COV_DIR = cov
COV_OPT = --force --all              \
          --enable DC.CUSTOM_CHECKER \
          --enable SECURE_TEMP       \
          --enable STRING_OVERFLOW   \
          --enable STRING_SIZE       \
          --enable TAINTED_SCALAR    \
          --enable TAINTED_STRING    \
          --enable USE_AFTER_FREE    \
          --dc-config /opt/coverity/stm-0117_model.json \
          --jobs 2

.PHONY: cov
cov:
	@make cov_build
	@make cov_analyze

.PHONY: cov_build
cov_build:
	@make clean
	@cov-build --dir $(COV_DIR) --encoding UTF-8 make

.PHONY: cov_analyze
cov_analyze:
	@cov-analyze --dir $(COV_DIR) $(COV_OPT)

.PHONY: cov_clean
cov_clean:
	@rm -rf $(COV_DIR)
