%{!?kernel_version:%{expand:%%global kernel_version 4.18.0-477.21.1.el8_8.x86_64}}

Name:           plxsdk
Version:        8.00
Release:        477.21.1%{?dist}
Summary:        PlxSdk

License:        GPLv2
URL:            http://ulm-git.vsp.cpg.sony.co.jp/ulm/vendor/PlxSdk

%define tag     V%(echo %{version} | %{__sed} 's/\\.//g')

%description
PlxSdk Svc Driver loader

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%define debug_package    %{nil}

%prep
%setup -T -c
/usr/bin/git clone --branch %{tag} --recurse-submodules %{url}.git .

%build
%{__make} KDIR=/lib/modules/%{kernel_version}/build
%{__make} KDIR=/lib/modules/%{kernel_version}/build svcdriver

%install
%make_install
find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
#%doc README
%license COPYING
%{_bindir}/*
%{_libdir}/*.so
/sony/ulm/drivers/*
/sony/ulm/rc.init/*

%files devel
#%doc add-devel-docs-here
%{_includedir}/*

%changelog
* Tue Sep  5 2023 Takeo Ugai <Takeo.Ugai@sony.com> - 8.00-477.21.1
- build for Rocky Linux 8.8 (4.18.0-477.21.1.el8_8.x86_64).

* Fri Jun 30 2023 Takeo Ugai <Takeo.Ugai@sony.com> - 8.00-477.15.1
- build for Rocky Linux 8.8 (4.18.0-477.15.1.el8_8.x86_64).

* Tue Sep 27 2022 Takeo Ugai <Takeo.Ugai@sony.com> - 8.00-372.26.1
- build for kernel-4.18.0-372.26.1.el8_6.x86_64.

* Thu Jun 16 2022 Takeo Ugai <Takeo.Ugai@sony.com> - 8.00-7
- build for Rocky Linux 8.6 (kernel-4.18.0-372.9.1.el8.x86_64).

* Fri Apr 15 2022 Takeo Ugai <Takeo.Ugai@sony.com> - 8.00-6
- build for kernel-4.18.0-348.20.1.el8_5.x86_64.

* Thu Mar  3 2022 Takeo Ugai <Takeo.Ugai@sony.com> - 8.00-5
- build for kernel-4.18.0-348.12.2.el8_5.x86_64.

* Fri Dec 17 2021 ULM Project <ulm-soft@vsp.cpg.sony.co.jp> - 8.00-4
- modify Requires

* Fri Nov 19 2021 Takeo Ugai <Takeo.Ugai@sony.com> - 8.00-3
- for kernel-4.18.0-305.25.1.el8_4.x86_64 (CentOS 8.4.2105).

* Thu Jun 10 2021 ULM Project <ulm-soft@vsp.cpg.sony.co.jp> - 8.00-2
- modify file owner

* Wed Jan 27 2021 ULM Project <ulm-soft@vsp.cpg.sony.co.jp> - 8.00
- release shared library

* Tue Jul 28 2020 ULM Project <ulm-soft@vsp.cpg.sony.co.jp> - 1.00_4
- specfile minor change

* Tue Jul 14 2020 ULM Project <ulm-soft@vsp.cpg.sony.co.jp> - 1.00-T
- Initial build
